/*
* March 2001, Junichi Morita
*  brightness control X-application for VAIO C1Vx
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Imlib.h>

#include "setdata.c"

#define VERSION	"0.1"

#define	IMGDIR		"/usr/local/share/xsetbrit"
#define	IMGFRAME	"frame.gif"

static int timeout=0;
static int value=1;
void timer()
{
// printf("timer %d\n",timeout);
	if ( timeout++ > 3 ) exit(0);
	alarm(2);
}

int main(argc,argv)
int argc;
char **argv;
{
	XtAppContext appc;
	Widget top;
	Arg arg[2];
	XSetWindowAttributes attr;
	KeySym ksm;
	Display *disp;
	ImlibData *id;
	Window win;
	ImlibImage *im,*ifm;
	XEvent xev;
	int w,h,size,dt,sx,sy;
	int wf,hf,sxf,syf;
	char fname[1024],ffname[1024],s[4];

	top=XtAppInitialize(&appc,"XSetBrit",NULL,0,&argc,argv,NULL,arg,(Cardinal)0);
	disp=XtDisplay(top);
	if( disp==NULL ){
		printf("Can't open display\n");
		exit(1);
	}
	id=Imlib_init(disp);

	/* must need to super user permission */
	setuid(0);
	value = dt = getdata(0x96)/0xf;
	/* loading frame image */
	sprintf(ffname,"%s/%s",IMGDIR,IMGFRAME);
	ifm=Imlib_load_image(id,ffname);
	wf=ifm->rgb_width;
	hf=ifm->rgb_height;
	sxf=0;
	syf=0;
	/* loading image for default value */
	sprintf(fname,"%s/brit%d.gif",IMGDIR,dt);
	im=Imlib_load_image(id,fname);
	w=im->rgb_width;
	h=im->rgb_height;
	sx=3;
	sy=3;
	win=XCreateWindow(disp,DefaultRootWindow(disp),0,0,w+6,h+6,0,
			id->x.depth,InputOutput,id->x.visual,0,&attr);
	XMapWindow(disp,win);
	XMoveWindow(disp,win,1024/2-(w/2),768/2-(h/2));
	XSync(disp,False);
	XClearWindow(disp,win);
	Imlib_paste_image(id,ifm,win,sxf,syf,wf,hf);
	Imlib_paste_image(id,im,win,sx,sy,w,h);
//	Imlib_kill_image(id, im);
//	im=NULL;
	XSync(disp,False);
	XSelectInput(disp,win,VisibilityChangeMask|ButtonPressMask|KeyPressMask);
	signal(SIGALRM,timer);
	alarm(2);
	while( 1 ){
		XNextEvent(disp,&xev);
		if( xev.type==KeyPress ){
		  size=XLookupString((XKeyEvent *)&xev,s,2,&ksm,0);
//		  printf("event <%x:%d:%x>\n",s[0],size,ksm);
		  timeout=0;
		  if((ksm&0xff)==0x53 || (ksm&0xff)==0x51 ){
		    /* change value and new image */
		    if( (ksm&0xff)==0x53 && value<16 ) value++;
		    if( (ksm&0xff)==0x51 && value>1 ) value--;
		    setdata(0x96,(value*0xf));
		    sprintf(fname,"%s/brit%d.gif",IMGDIR,value);
		    if( im ) Imlib_kill_image(id,im);
		    im=Imlib_load_image(id,fname);
		    Imlib_paste_image(id,ifm,win,sxf,syf,wf,hf);
		    Imlib_paste_image(id,im,win,sx,sy,w,h);
//		    Imlib_kill_image(id, im);
		    XSync(disp,False);
		  }
		}else if( xev.type==VisibilityNotify ){
		  /* refresh images */
		  XClearWindow(disp,win);
		  Imlib_paste_image(id,ifm,win,sxf,syf,wf,hf);
		  Imlib_paste_image(id,im,win,sx,sy,w,h);
		  XSync(disp,False);
		}else if (xev.type==DestroyNotify ){
		  printf("Window Destroy!!\n");
		}else{
//		  printf("event [%d]\n",xev.type);
		}
		XSync(disp,False);
	}

exit(0);
}
